/*
 * Arquivo para teste do deque
 * Operaes possveis:
 *     - ii <e>  insere <e> no incio do deque
 *     - if <e>  insere <e> no final do deque
 *     - ri      remove o elemento no incio do deque
 *     - rf      remove o elemento no final do deque
 *     - l       libera o deque
 */
#include <stdio.h>
#include "deque.h"

int main() {
  Deque d;
  char c, c1;
  int r, e;

  cria_deque(&d);
  while (scanf ("%c", &c) != EOF) {
    switch (c) {
    case 'i':                        /* Inseres */
      r = scanf ("%c %d", &c1, &e);
      if (r < 2)
	printf ("erro na entrada.\n");
      else {
	switch (c1) {
	case 'i':
	  insere_inicio_deque(&d,e);
	  break;
	case 'f':
	  insere_fim_deque(&d,e);
	  break;
	default:
	  printf ("erro na entrada.\n");
	  break;
	}
      }
      break;
    case 'r':                        /* Remoes */
      scanf ("%c", &c1);
      switch (c1) {
      case 'i':
	r = remove_inicio_deque(&d,&e);
	break;
      case 'f':
	r = remove_fim_deque(&d,&e);
	break;
      default:
	r = 0;
	printf ("erro na entrada.\n");
	break;
      }
      if (r == 0)
	printf("remoo sem sucesso\n");
      break;
    case 'v':
      if (deque_vazio(&d))
	  printf("deque vazio.\n");
	else
	  printf("deque com elementos.\n");
      break;
    }
  }

  return 0;
}
